#include <iostream>

using namespace std;

const int MaxN=100;
struct Temp{
    int maxt;
    int mint;
};

void readingWithChecking(int&,Temp[]);
void solveIt(int,const Temp[],int&,int[]);

int main()
{
    cout << "Hello world!" << endl;

    /// declaration

    int N;
    Temp Days[MaxN];

    int NCnt;
    int OutDays[MaxN];

    /// input
    readingWithChecking(N,Days);

    /// implement algorithm
    solveIt(N,Days,NCnt,OutDays);

    /// output
    cout << NCnt << endl;
    for (int i=0;i<NCnt;i++) {
        cout << OutDays[i] << " ";
    }
    cout << endl;

    return 0;
}

void readingWithChecking(int &CNT,Temp X[]){
    bool error=false;
    string tmp;
    do {
        cout << "N=? :";
        cin >> tmp;
        CNT=atoi(tmp.c_str());
        error=((CNT<=0) || (MaxN<CNT));
        if (error) {
            cout << " ERROR! N must be between 1 and " << MaxN << "!" << endl;
        }
    } while (error);

    for (int i=0;i<CNT;i++) {
        do {
            cout << (i+1) << ". data:" << endl;
            do {
                cout << "  min temp=? :";
                cin >> tmp;
                X[i].mint=atoi(tmp.c_str());
                error=((X[i].mint==0) && (tmp!="0"));
                if (error) {
                    cout << " ERROR! mint must be an integer number" << endl;
                }
            } while (error);

            do {
                cout << "  max temp=? :";
                cin >> tmp;
                X[i].maxt=atoi(tmp.c_str());
                error=((X[i].maxt==0) && (tmp!="0"));
                if (error) {
                    cout << " ERROR! maxt must be an integer number" << endl;
                }
            } while (error);

            error=(X[i].mint>X[i].maxt);
            if (error) {
                cout << " ERROR! maxt must be grater than or equal mint" << endl;
            }

        } while (error);
    }
}

void solveIt(int N,const Temp Days[],int &NCnt,int OutDays[]){
    int MaxDif=Days[0].maxt-Days[0].mint;
    NCnt=0;
    OutDays[NCnt]=1;
    NCnt++;
    for (int i=1;i<N;i++) {
        if (Days[i].maxt-Days[i].mint==MaxDif) {
            OutDays[NCnt]=(i+1);
            NCnt++;
        }
        if (Days[i].maxt-Days[i].mint>MaxDif) {
            NCnt=0;
            OutDays[NCnt]=(i+1);
            NCnt++;
            MaxDif=Days[i].maxt-Days[i].mint;
        }
    }
}

